<?php
namespace Teknisa\CNC\Factories;

use Doctrine\ORM\EntityManager;

class Cnc00300ProdutoAdquirenteFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getProdAdq($params){
        $sql = "SELECT PR.NRPRODUTOADQ, PR.CDPRODUTOADQ, PR.CDPRODADQEXT, PR.NMPRODUTOADQ, PR.CDTIPORECE, 
            TR.NMTIPORECE, PR.VRTOLERANCIA, PR.IDATIVO, PR.NRORG, PR.NRBANDEIRAVAN, 
            BAND.NMBANDEIRA, BAND.CDBANDEIRA, 'Sim' ATIVO, PR.IDVISIVEL   
            FROM PRODUTOADQ PR 
             LEFT JOIN BANDEIRAVAN BAND 
              ON PR.NRBANDEIRAVAN = BAND.NRBANDEIRAVAN 
               LEFT JOIN TIPORECE TR 
                ON PR.CDTIPORECE = TR.CDTIPORECE 
            WHERE PR.NRORG = :NRORG 
            AND PR.IDATIVO = 'S'
         ORDER BY NMPRODUTOADQ";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getProdutosGer($params){
        $sql = "SELECT PR.NRPRODUTOADQ, PR.CDPRODUTOADQ, PR.CDPRODADQEXT, PR.NMPRODUTOADQ, PR.CDTIPORECE, 
            TR.NMTIPORECE, PR.VRTOLERANCIA, PR.IDATIVO, PR.NRORG, PR.NRBANDEIRAVAN, 
            BAND.NMBANDEIRA, BAND.CDBANDEIRA, 'Sim' ATIVO, PR.IDVISIVEL   
            FROM PRODUTOADQ PR 
             LEFT JOIN BANDEIRAVAN BAND 
              ON PR.NRBANDEIRAVAN = BAND.NRBANDEIRAVAN 
               LEFT JOIN TIPORECE TR 
                ON PR.CDTIPORECE = TR.CDTIPORECE 
            WHERE PR.NRORG = :NRORG
            AND UPPER(PR.CDPRODUTOADQ|| ' - ' ||PR.NMPRODUTOADQ) LIKE UPPER(:LABELPRODUTOADQ)
            AND PR.IDATIVO = 'S' 
         ORDER BY NMPRODUTOADQ";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getProdutos($params){
        $sql = "SELECT PR.NRPRODUTOADQ, PR.CDPRODUTOADQ, PR.CDPRODADQEXT, PR.NMPRODUTOADQ, PR.CDTIPORECE, 
        TR.NMTIPORECE, PR.CDPRODUTOADQ|| ' - ' ||PR.NMPRODUTOADQ LABELPRODUTOADQ, 
        PR.VRTOLERANCIA, PR.IDATIVO, PR.NRORG, PR.NRBANDEIRAVAN, BAND.NMBANDEIRA, BAND.CDBANDEIRA, 
        PR.NRDIASVENC, 'Sim' ATIVO, PR.IDVISIVEL, DECODE (PR.IDVISIVEL, 'S', 'Sim' , 'Não') LBIDVISIVEL
        FROM PRODUTOADQ PR 
            LEFT JOIN BANDEIRAVAN BAND 
             ON PR.NRBANDEIRAVAN = BAND.NRBANDEIRAVAN 
                LEFT JOIN TIPORECE TR 
                 ON PR.CDTIPORECE = TR.CDTIPORECE
         WHERE PR.NRORG = :NRORG 
          AND ((INSTR ( UPPER(PR.NMPRODUTOADQ ||
                        PR.CDTIPORECE ||
                        TR.NMTIPORECE || 
                        DECODE (PR.IDVISIVEL, 'S', 'Sim' , 'Não')),
                        UPPER(:ALL_FIELDS)) <> 0) OR (:TALL_FIELDS = 'T'))
          AND ((INSTR (:NRPRODUTOADQ, '|'||TO_CHAR(NRPRODUTOADQ)||'|') > 0) OR ('T' = :TNRPTODUTOADQ))
          AND ((INSTR (:CDTIPORECE, '|'||TO_CHAR(PR.CDTIPORECE)||'|') > 0) OR ('T' = :TCDTIPORECE))
          AND PR.IDATIVO = 'S' 
         ORDER BY NMPRODUTOADQ";

                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getProdutosFiltered($query){
        $sql = $query;
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function fetchTipoRece($params){
        $sql = "SELECT PR.CDTIPORECE, TR.NMTIPORECE, PR.NMPRODUTOADQ
                FROM PRODUTOADQ PR, TIPORECE TR
                WHERE PR.CDTIPORECE = :CDTIPORECE
                  AND PR.CDTIPORECE = TR.CDTIPORECE";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function saveProduct($params) {
        $sql = "UPDATE PRODUTOADQ 
                  SET VRTOLERANCIA = :VRTOLERANCIA, 
                  DTULTATU = :DTULTATU,
                  NRORGULTATU = :NRORGULTATU,
                  CDOPERULTATU = :CDOPERULTATU,
                  NRBANDEIRAVAN = :NRBANDEIRAVAN,
                  IDVISIVEL    = :IDVISIVEL,
                  NRDIASVENC    = :NRDIASVENC
                WHERE NRORG = :NRORG 
                  AND IDATIVO = :IDATIVO
                  AND NRPRODUTOADQ = :NRPRODUTOADQ
                  AND CDPRODUTOADQ = :CDPRODUTOADQ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveTypeUpdateAdq($params) {
        $sql = "UPDATE TAXAADQPROD
                  SET VRTAXAADM = :VRTAXAADM,
                  DTULTATU = :DTULTATU,
                  NRORGULTATU = :NRORGULTATU,
                  CDOPERULTATU = :CDOPERULTATU,
                  NRDIASVENC = :NRDIASVENC
                WHERE NRORG = :NRORG
                  AND IDATIVO = :IDATIVO
                  AND NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ
                  AND NRTAXAADQPROD = :NRTAXAADQPROD
                  AND NRESTABELEC IS NULL";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveTypeInsertAdq($params) {
        $sql = "INSERT INTO TAXAADQPROD
                  (NRTAXAADQPROD, NRADQUIRENTE, NRPRODUTOADQ, VRTAXAADM, NRORG, IDATIVO, DTULTATU, NRORGULTATU, CDOPERULTATU, NRDIASVENC)
                VALUES
                  (:NRTAXAADQPROD, :NRADQUIRENTE, :NRPRODUTOADQ, :VRTAXAADM, :NRORG, :IDATIVO, :DTULTATU, :NRORGULTATU, :CDOPERULTATU, :NRDIASVENC)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getNrSequencialFromTaxaAdqProd($params) {
        $sql = "SELECT NRTAXAADQPROD
                FROM TAXAADQPROD
                WHERE NRORG = :NRORG
                  AND IDATIVO = :IDATIVO
                ORDER BY NRTAXAADQPROD";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function checkRowIsNotNull($params) {
        $sql = "SELECT NRTAXAADQPROD
                FROM TAXAADQPROD
                WHERE NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ
                  AND NRORG = :NRORG
                  AND IDATIVO = :IDATIVO
                  AND NRESTABELEC IS NULL";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    
    
    public function saveEstabelec($params) {
        $sql = "INSERT INTO TAXAADQPROD
                  (NRADQUIRENTE, NRPRODUTOADQ, NRESTABELEC, VRTAXAADM, NRTAXAADQPROD, NRORG, IDATIVO, DTULTATU, NRORGULTATU, CDOPERULTATU)
                VALUES
                  (:NRADQUIRENTE, :NRPRODUTOADQ, :NRESTABELEC, :VRTAXAADM, :NRTAXAADQPROD, :NRORG, :IDATIVO, :DTULTATU, :NRORGULTATU, :CDOPERULTATU)";
                    
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getEstabelecFromTaxaAdqProd($params) {
        $sql = "SELECT *
                FROM TAXAADQPROD
                WHERE NRESTABELEC = :NRESTABELEC
                  AND NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ
                  AND NRORG = :NRORG
                  AND IDATIVO = :IDATIVO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getEstabelecFromTaxaAdqProdEdit($params) {
        $sql = "SELECT *
                FROM TAXAADQPROD
                WHERE NRESTABELEC = :NRESTABELEC
                  AND NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ
                  AND NRTAXAADQPROD <> :NRTAXAADQPROD
                  AND NRORG = :NRORG
                  AND IDATIVO = :IDATIVO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function isTotalEstabelec($params) {
        $sql = "SELECT DECODE(EST.CDESTABELEC|| ' - ' ||EST.NMESTABELEC, ' - ', 'Todos', EST.CDESTABELEC|| ' - ' ||EST.NMESTABELEC) LABELESTABELEC  
        FROM TAXAADQPROD TAP 
                    LEFT JOIN ESTABELECIMENTO EST 
                             ON TAP.NRESTABELEC = EST.NRESTABELEC, PRODUTOADQ PRO 
           WHERE TAP.NRORG = :NRORG 
                AND TAP.IDATIVO = :IDATIVO 
                AND TAP.NRPRODUTOADQ = PRO.NRPRODUTOADQ 
                AND TAP.NRADQUIRENTE = :NRADQUIRENTE 
                AND TAP.NRPRODUTOADQ = :NRPRODUTOADQ 
        ORDER BY TAP.NRTAXAADQPROD";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function saveEditEstabelec($params) {
        $sql = "UPDATE TAXAADQPROD
                  SET VRTAXAADM = :VRTAXAADM,
                  NRESTABELEC = :NRESTABELEC,
                  DTULTATU = :DTULTATU,
                  NRORGULTATU = :NRORGULTATU,
                  CDOPERULTATU = :CDOPERULTATU
                WHERE NRORG = :NRORG
                  AND IDATIVO = :IDATIVO
                  AND NRTAXAADQPROD = :NRTAXAADQPROD
                  AND NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function saveEditEstabelecType2($params) {
        $sql = "UPDATE TAXAADQPROD
                  SET VRTAXAADM = :VRTAXAADM,
                  DTULTATU = :DTULTATU,
                  NRORGULTATU = :NRORGULTATU,
                  CDOPERULTATU = :CDOPERULTATU
                WHERE NRORG = :NRORG
                  AND IDATIVO = :IDATIVO
                  AND NRTAXAADQPROD = :NRTAXAADQPROD
                  AND NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ";
                  
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function removeEstabelec($params) {
        $sql = "DELETE FROM TAXAADQPROD
                WHERE NRORG = :NRORG
                  AND IDATIVO = :IDATIVO
                  AND NRTAXAADQPROD = :NRTAXAADQPROD
                  AND NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ
                  AND NRESTABELEC = :NRESTABELEC";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function removeTaxaAdqProd($params) {
        $sql = "DELETE FROM TAXAADQPROD
                WHERE NRORG = :NRORG
                  AND IDATIVO = :IDATIVO
                  AND NRTAXAADQPROD = :NRTAXAADQPROD
                  AND NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function removeProdAdq($params) {
        $sql = "DELETE FROM TAXAADQPROD
                WHERE NRORG = :NRORG
                  AND IDATIVO = :IDATIVO
                  AND NRTAXAADQPROD = :NRTAXAADQPROD
                  AND NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function getNrSequencialFromEstabelecToRemove($params) {
        $sql = "SELECT NRTAXAADQPROD
                FROM TAXAADQPROD
                WHERE NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ
                  AND NRORG = :NRORG
                  AND IDATIVO = :IDATIVO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getNrSequencialFromEstabelecToRemoveEst($params) {
        $sql = "SELECT NRTAXAADQPROD
                FROM TAXAADQPROD
                WHERE NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ
                  AND NRESTABELEC = :NRESTABELEC
                  AND NRORG = :NRORG
                  AND IDATIVO = :IDATIVO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getNrSequencialToRemove($params) {
        $sql = "SELECT NRTAXAADQPROD
                FROM TAXAADQPROD
                WHERE NRADQUIRENTE = :NRADQUIRENTE
                  AND NRPRODUTOADQ = :NRPRODUTOADQ
                  AND NRESTABELEC IS NULL
                  AND NRORG = :NRORG
                  AND IDATIVO = :IDATIVO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function getPeriodTaxa($params){
    $sql = "SELECT TX.NRTAXAPERADQ, TO_CHAR(TX.DTINICIAL, 'DD/MM/YYYY') DTINICIAL, TO_CHAR(TX.DTFINAL, 'DD/MM/YYYY') DTFINAL, TX.VRTAXAADM 
             FROM TAXAPERADQ TX, PRODUTOADQ P, ADQUIRENTE A
              WHERE TX.NRADQUIRENTE = A.NRADQUIRENTE
              AND TX.NRPRODUTOADQ = P.NRPRODUTOADQ
              AND A.NRADQUIRENTE = :NRADQUIRENTE
              AND P.NRPRODUTOADQ = :NRPRODUTOADQ";
    $std = $this->connection->prepare($sql);
    $std->execute($params);
    return $std->fetchAll();
    }

    public function getPeriodTaxaRow($params){
    $sql = "SELECT TX.NRTAXAPERADQ, TO_CHAR(TX.DTINICIAL, 'DD/MM/YYYY') DTINICIAL, TO_CHAR(TX.DTFINAL, 'DD/MM/YYYY') DTFINAL, TX.VRTAXAADM 
             FROM TAXAPERADQ TX, PRODUTOADQ P, ADQUIRENTE A
              WHERE TX.NRADQUIRENTE = A.NRADQUIRENTE
              AND TX.NRPRODUTOADQ = P.NRPRODUTOADQ
              AND A.NRADQUIRENTE = :NRADQUIRENTE
              AND P.NRPRODUTOADQ = :NRPRODUTOADQ
              AND TX.NRTAXAPERADQ = :NRTAXAPERADQ";
    $std = $this->connection->prepare($sql);
    $std->execute($params);
    return $std->fetchAll();
    }

    public function alterarPeriodoTaxa($params){
    $sql = "UPDATE TAXAPERADQ
                SET DTINICIAL   = :DTINICIAL,
                DTFINAL         = :DTFINAL,
                VRTAXAADM       = :VRTAXAADM
            WHERE NRADQUIRENTE  = :NRADQUIRENTE
            AND   NRPRODUTOADQ  = :NRPRODUTOADQ
            AND   NRTAXAPERADQ  = :NRTAXAPERADQ";
    $std = $this->connection->prepare($sql);
    $std->execute($params);
    }

    public function inserirPeriodoTaxa($params){
    $sql = "INSERT INTO TAXAPERADQ
              (NRTAXAPERADQ, NRADQUIRENTE, NRPRODUTOADQ, DTINICIAL, DTFINAL, VRTAXAADM) 
            VALUES
              (:NRTAXAPERADQ, :NRADQUIRENTE, :NRPRODUTOADQ, :DTINICIAL, :DTFINAL, :VRTAXAADM)";
    $std = $this->connection->prepare($sql);
    $std->execute($params);
    }

    public function deletarPeriodoTaxa($params){
    $sql = "DELETE 
                FROM TAXAPERADQ
                WHERE NRADQUIRENTE = :NRADQUIRENTE
                AND NRPRODUTOADQ = :NRPRODUTOADQ
                AND NRTAXAPERADQ = :NRTAXAPERADQ";
    $std = $this->connection->prepare($sql);
    $std->execute($params);
    }

    public function verificaIntervalo($params){
    $sql = "SELECT COUNT(*) QUANTIDADE
              FROM TAXAPERADQ
             WHERE (((:DTINICIAL BETWEEN DTINICIAL AND DTFINAL)
                OR (:DTFINAL BETWEEN DTINICIAL AND DTFINAL))
                OR ((DTINICIAL BETWEEN :DTINICIAL AND :DTFINAL)
                OR (DTFINAL BETWEEN :DTINICIAL AND :DTFINAL)))
                AND NRADQUIRENTE = :NRADQUIRENTE
                AND NRPRODUTOADQ = :NRPRODUTOADQ";
    $std = $this->connection->prepare($sql);
    $std->execute($params);
    return $std->fetchAll();
    }

    public function verificaIntervaloAlterar($params){
   $sql = "SELECT COUNT(*) QUANTIDADE
              FROM TAXAPERADQ
             WHERE (((:DTINICIAL BETWEEN DTINICIAL AND DTFINAL)
                OR (:DTFINAL BETWEEN DTINICIAL AND DTFINAL))
                OR ((DTINICIAL BETWEEN :DTINICIAL AND :DTFINAL)
                OR (DTFINAL BETWEEN :DTINICIAL AND :DTFINAL)))
              AND NRADQUIRENTE = :NRADQUIRENTE
              AND NRPRODUTOADQ = :NRPRODUTOADQ
              AND NRTAXAPERADQ <> :NRTAXAPERADQ";
    $std = $this->connection->prepare($sql);
    $std->execute($params);
    return $std->fetchAll();
    }
    
    
   public function registerExists($params){
   $sql = "SELECT * FROM TAXAADQPARC 
            WHERE NRORG = :NRORG 
            AND NRADQUIRENTE = :NRADQUIRENTE
            AND NRPRODUTOADQ = :NRPRODUTOADQ
            AND QTPARCELA = :QTPARCELA";
    $std = $this->connection->prepare($sql);
    $std->execute($params);
    return $std->fetchAll();
    }
}